import es, popuplib, playerlib, gamethread, cmdlib, usermsg
import nativetools as nt # http://forums.eventscripts.com/viewtopic.php?t=32582


###############################################
## Addon Info
###############################################

info = es.AddonInfo()
info.name        = 'HitMod'
info.version     = '1.2.7'
info.author      = 'DanielB - www.customsource.info'
info.basename    = 'hitmod'
info.description = 'Allows terrorists to place bountys on each other'

###############################################
## Classes
###############################################

class Manager:
    def __init__(self):
        self.target = 0
        self.canHit = True
        self.lastff = 0
        
        self.ff = es.ServerVar('mp_friendlyfire')
        es.flags('remove', 'notify', 'mp_friendlyfire')
        self.ffvalue = str(self.ff)
        
        self.last = []
        self.tname = None
        
    def cleanup(self):
        es.ServerVar('mp_friendlyfire').set(self.ffvalue)
        es.flags('add', 'notify', 'mp_friendlyfire')
    
    def __bool__(self): # Check if there is an active bounty
        return bool(self.target)
        
    def placeBounty(self, userid):
        self.target = int(userid)
        self.ff.set(1)
        self.canHit = False
        self.tname = es.getplayername(userid)
    
    def pre_player_hurt2(self, ev):
        
        victim   = nt.preEventGetInt('userid')
        attacker = nt.preEventGetInt('attacker')
        damage   = nt.preEventGetInt('dmg_health')
        
        x = [victim, attacker, damage]
        if self.last == x:
            self.last = []
            return
        else:
            self.last = x
        
        if self.target:
            if es.getplayerteam(victim) == es.getplayerteam(attacker):
                if victim != self.target:
                    playerlib.getPlayer(victim).health += damage
                else:
                    player = playerlib.getPlayer(victim)
                    usermsg.saytext2('#all', player.index, '\4[HitMod] \3%s\1 has attacked \3%s'%(es.getplayername(attacker), es.getplayername(victim)))
                    if ev['weapon'] == 'knife':
                        if damage >= 20:
                            player.health += damage-3
                        else:
                            player.health += damage-1
                    
                    
        elif es.getplayerteam(victim) == es.getplayerteam(attacker):
            if int(attacker) != 0 and attacker != victim:
                playerlib.getPlayer(victim).health += damage
    
    def player_death(self, ev):
        if self.target:
            victim = int(ev['userid'])
            if victim == self.target:
                if es.getplayerteam(ev['attacker']) == 2:
                    if ev['attacker'] not in ('0', str(self.target)):
                        msg('%s killed %s and claimed the 5k reward!'%(es.getplayername(ev['attacker']), es.getplayername(self.target)))
                        #cash = es.getplayerprop(ev['attacker'], 'CCSPlayer.m_iAccount')
                        #es.setplayerprop(ev['attacker'], 'CCSPlayer.m_iAccount', cash+5000)
                        playerlib.getPlayer(ev['attacker']).cash += 5000
                    else:
                        msg('%s died before someone could claim his bounty!'%es.getplayername(self.target))
                
                self.target = 0
                self.ff.set(0)
                
    def dc(self, userid):
        if int(userid) == self.target:
            msg('%s has disconnected! The hit has been called off!'%self.tname)
            self.target = 0
            self.ff.set(0)
            self.canHit = True
                
    def round_end(self):
        if self.target:
            if es.exists('userid', self.target):
                msg('%s survived without anyone claiming the bounty!'%es.getplayername(self.target))
                #cash = es.getplayerprop(self.target, 'CCSPlayer.m_iAccount')
                #es.setplayerprop(self.target, 'CCSPlayer.m_iAccount', cash+10000)
                playerlib.getPlayer(self.target).cash += 10000
                self.target = 0
                self.ff.set(0)
        self.canHit = True
        
###############################################
## Class Instances
###############################################

bounty = Manager()

###############################################
## Events
###############################################

def player_death(ev): bounty.player_death(ev)
def round_end(ev): bounty.round_end()
def player_disconnect(ev): bounty.dc(ev['userid'])
        
def sendPopup(userid):
    userid = int(userid)
    popupname = 'hitmod_playerlist_%s'%userid
    delPop(popupname)
    p = popuplib.easymenu(popupname, None, placeBounty)
    p.settitle('Hit Mod')
    p.setdescription('Pay $16k to place a bounty on a terrorist!')
    for i in es.getUseridList():
        if i != userid and es.getplayerteam(i) == 2 and not playerlib.getPlayer(i).isdead:
            p.addoption(i, es.getplayername(i))
    p.send(userid)
        
###############################################
## Callbacks (popuplib, cmdlib, etc)
###############################################

def cmd_hit(userid, args):
    popuplib.send('hitmod_main', userid)

def mainSelect(userid, choice, popupname):
    choice = int(choice)
    if choice == 1:
        sendPopup(userid)
    elif choice == 2:
        popuplib.send('hitmod_info', userid)

def placeBounty(userid, choice, popupname):
    delPop(popupname)
    if (not bounty.target) and es.getplayerteam(userid) == 2:
        if bounty.canHit:
            if not playerlib.getPlayer(choice).isdead:
                cash = int(es.getplayerprop(userid, 'CCSPlayer.m_iAccount'))
                if cash >= 16000:
                    es.setplayerprop(userid, 'CCSPlayer.m_iAccount', cash-16000)
                    bounty.placeBounty(choice)
                    #msg('%s placed a bounty on %ss head!'%(es.getplayername(userid), es.getplayername(choice)))
                
                    aname = es.getplayername(userid)
                    vname = es.getplayername(choice)
                    ic = int(choice)
                    for i in playerlib.getUseridList('#t,#alive'):
                        if int(i) != ic:
                            tell(i, '%s placed a bounty on %ss head!'%(aname, vname))
                else:
                    tell(userid, 'You cannot afford to place the bounty!')
            else:
                tell(userid, 'You cannot place a bounty on a dead player!')
        else:
            tell(userid, 'Only one bounty can be placed per round')
    else:
        tell(userid, 'You cannot place a bounty at this time')
        
###############################################
## Load/Unload
###############################################

def load():
    advert()
    p = popuplib.create('hitmod_info')
    p.addline('HitMod')
    p.addline('--------------------')
    p.addline('Hit mod allows terrorists to place')
    p.addline('hits on other terrorists.')
    p.addline('Whoever kills the targeted T recieves')
    p.addline('$5k, but if he survives the targeted T')
    p.addline('recieves $10k. Placing a hit costs $16k')
    p.addline('0 - Exit')
    
    p = popuplib.create('hitmod_main')
    p.addline('HitMod')
    p.addline('--------------------')
    p.addline('->1 - Place a hit')
    p.addline('->2 - More Info')
    p.menuselect = mainSelect
    
    cmdlib.registerSayCommand('!hit', cmd_hit, 'HitMod menu')
    
    es.dbgmsg(0, '[HM-DBG] Registering PreHook')
    #spe.registerPreHook('player_hurt', pre_player_hurt)
    nt.preEventRegister("player_hurt", pre_player_hurt)
    es.dbgmsg(0, '[HM-DBG] Done PreHook')
    msg('Loaded %s'%info.version)
    
    
def unload():
    #spe.unregisterPreHook('player_hurt', pre_player_hurt)
    nt.preEventUnregister("player_hurt", pre_player_hurt)
    bounty.cleanup()
    gamethread.cancelDelayed('hitmod_advert')
    cmdlib.unregisterSayCommand('!hit')
    msg('Unloaded')
    
###############################################
## Misc Functions
###############################################

def advert():
    msg('Type !hit to place a hit on a fellow T')
    gamethread.delayedname(30, 'hitmod_advert', advert)

def pre_player_hurt(ev): bounty.pre_player_hurt2(ev)

def msg(text):
    es.msg('#multi', '#green[HitMod]#lightgreen '+text)
    
def tell(userid, text):
    es.tell(userid, '#multi', '#green[HitMod]#lightgreen '+text)
    
def delPop(pname):
    if popuplib.exists(pname): popuplib.delete(pname)
    